/* Brown Recluse                       */
/* Deep Web Tour Companion Application */
/* 2014 3am LLC - http://3amteam.com   */

/* Section Load Functions */
function BR_load_initCanvas()
{
    THREEAM_DRAWING();
    BR_action_pickColor(null,"random");
}
function BR_load_fixTable()
{
    function fixTable()
    {
        $("#choice .choicearray img").each(function(){
            //$(this).height($(this).parent().height()*.90);
        });
    }
    window.addEventListener("resize",fixTable);
    fixTable();
}
function BR_load_chatHandler()
{
    var send = $("#chatSend");
    
    var hasUser = false;
    var hasMsg  = false;
    send.css("display","none");
    
    if($("#textName").val().replace(" ","")!=""){hasUser = true;}
    $("#textMessage").val("");
    
    function enableSend()
    {
        if(hasUser && hasMsg){send.css("display","block");}
        else{send.css("display","none");}
    }
    
    enableSend();
    
    $("#textName").bind("keyup",function(){
        if(this.value.replace(" ","") != "")
        {
            hasUser = true;
        }else{hasUser = false;}
        enableSend();
    });
    $("#textMessage").bind("keyup",function(){
        if(this.value.replace(" ","") != "")
        {
            hasMsg = true;
        }else{hasMsg = false;}
        enableSend();
    });
}
function BR_load_powerHandler()
{
    var button = $("#startbutton");
    button.bind("mousedown touchstart touchenter",function(e){
        e.preventDefault && e.preventDefault();
        e.stopPropagation && e.stopPropagation();
        e.cancelBubble = true;
        e.returnValue = false;
        
        $("#spinner")[0].style.webkitAnimationPlayState = "paused";
        $("#spinner")[0].style.mozAnimationPlayState = "paused";
        $("#spinner")[0].style.msAnimationPlayState = "paused";
        $("#spinner")[0].style.animationPlayState = "paused";
        
        $("#spinner")[0].style.animationDuration="0.5s";
        $("#spinner")[0].style.webkitAnimationDuration="0.5s";
        $("#spinner")[0].style.mozAnimationDuration="0.5s";
        $("#spinner")[0].style.msAnimationDuration="0.5s";
        
        $("#spinner")[0].style.display = "none";
        
        $("#gradientarea").addClass("on");
        $("#horizgradientarea").css("opacity","1");
        setTimeout(function(){
            $("#spinner")[0].style.webkitAnimationPlayState = "running";
            $("#spinner")[0].style.mozAnimationPlayState = "running";
            $("#spinner")[0].style.msAnimationPlayState = "running";
            $("#spinner")[0].style.animationPlayState = "running";
            $("#spinner")[0].style.display = "";
        },0);
    });
    function startAnim(e)
    {
        e.preventDefault && e.preventDefault();
        e.stopPropagation && e.stopPropagation();
        e.cancelBubble = true;
        e.returnValue = false;
        
        $("#spinner")[0].style.webkitAnimationPlayState = "paused";
        $("#spinner")[0].style.mozAnimationPlayState = "paused";
        $("#spinner")[0].style.msAnimationPlayState = "paused";
        $("#spinner")[0].style.animationPlayState = "paused";
        
        $("#spinner")[0].style.animationDuration="4s";
        $("#spinner")[0].style.webkitAnimationDuration="4s";
        $("#spinner")[0].style.mozAnimationDuration="4s";
        $("#spinner")[0].style.msAnimationDuration="4s";

        $("#spinner")[0].style.display = "none";
        
        $("#gradientarea").removeClass("on");
        $("#horizgradientarea").css("opacity","0");
        setTimeout(function(){
            $("#spinner")[0].style.webkitAnimationPlayState = "running";
            $("#spinner")[0].style.mozAnimationPlayState = "running";
            $("#spinner")[0].style.msAnimationPlayState = "running";
            $("#spinner")[0].style.animationPlayState = "running";
            $("#spinner")[0].style.display = "";
        },0);
    }
    button.bind("mouseup touchend touchleave",startAnim);
    startAnim();
}
/* Click Action Functions */
function BR_action_pickColor(e,rand)
{
    var color, colorbutton, colorcode;
    colorbutton = document.getElementById("drawColor");
    if(typeof rand !== undefined && rand == "random")
    {
        var colors = ["blue","lightblue","white"];
        color = colors[Math.floor(Math.random()*colors.length)];
    }else{
        var coord1 = e.target.src.search("draw.button")+11;
        var coord2 = e.target.src.search(".svg");
        color = e.target.src.substring(coord1,coord2);
    }
    switch(color)
    {
        case "blue":
            colorcode = "#5FD4FF";
            break;
        case "lightblue":
            colorcode = "#B9ECFF";
            break;
        case "white":
            colorcode = "#FFFFFF";
            break;
    }
    CORE_loadSVGImage(colorbutton,colorbutton.src.substring(0,colorbutton.src.search("draw.")+5)+"draw.color"+color+".svg");
    style.color = colorcode;
    document.getElementById("colorPicker").style.display = "none";
}
function BR_action_colorDialog()
{
    var colorpicker = document.getElementById("colorPicker");
    if(colorpicker.style.display == "block")
    {
        colorpicker.style.display = "none"; 
    }else{
        colorpicker.style.display = "block";   
    }
}
function BR_action_submitVote(e)
{
    var remove = "";
    $("#choice .choicearray img").each(function(){
        var nsrc = $(this).attr('src').replace("fill.svg",".svg");
        if(nsrc != $(this).attr('src'))
        {
            CORE_loadSVGImage(this,nsrc);
            remove = $(this).attr('id');
        }
    });
    CORE_loadSVGImage(e.target,$(e.target).attr('src').replace(".svg","fill.svg"));
    BR_addVote($(e.target).attr('id'),remove);
}
function BR_action_submitVoteNSong(e)
{
    var remove = "";
    $("#newsong .choicearray img").each(function(){
        var nsrc = $(this).attr('src').replace("fill.svg",".svg");
        if(nsrc != $(this).attr('src'))
        {
            CORE_loadSVGImage(this,nsrc);
            remove = $(this).attr('id');
        }
    });
    CORE_loadSVGImage(e.target,$(e.target).attr('src').replace(".svg","fill.svg"));
    BR_addVoteNSong($(e.target).attr('id'),remove);
}
function BR_action_unlock()
{
    CORE_switchToPage(BR_getPageFromStatusCode(THREEAM_NETWORK_STATUS),
                      BR_getColorFromStatusCode(THREEAM_NETWORK_STATUS));
}
function BR_action_launchDrawing()
{
    CORE_switchToPage("draw");
}
function BR_action_clearDrawing()
{
	THREEAM_DRAWING();
	var send = document.getElementById("drawSend");
	send.style.display = "none";
    window.DrawWaiting = false;
}
function BR_action_sendDrawing()
{
    var data = exportStrokes();
    window.OKToDraw = false;
    window.DrawWaiting = false;
    BR_submitDrawing({vector:data});
    BR_action_clearDrawing();
}
function BR_action_sendMessage()
{
    var name = $("#textName").val();
    var msg = $("#textMessage").val();
    var data = {message:msg,username:name,sender:"0"};
    BR_sendMessage(data);
    $("#textMessage").val("");
	$("#chatSend").css("display","none");
}
function BR_action_sendStartVote()
{
    //BR_sendStartVote();
    //This doesn't need to happen anymore.
}
function BR_action_launchPassword()
{
	CORE_switchToPage("password");
}
function BR_action_launchText()
{
	CORE_switchToPage("chat");
}
