/* Brown Recluse                       */
/* Deep Web Tour Companion Application */
/* 2014 3am LLC - http://3amteam.com   */

var BR_majorVersionNumber = 3;

function BR_startApplication()
{	
	// Fix iOS 7
    CORE_iOSStatusBarCompensationEnabler("#000000");    
    CORE_deflColor = "#26beea";
    
	// Change URL in Address Bar
	if((typeof window.cordova == "undefined")&& !(typeof window.navigator.standalone !== "undefined" && window.navigator.standalone == true))
	{
		if (history && history.pushState && location.hostname.match('thedeepwebtour')){ history.pushState(null, null, 'http://app.thedeepwebtour.com/');}
	}
	
	// We use actions support in this application. Enable it.
	CORE_addActionSupport("BR");
    
    // We need geolocation to enforce the venue restrictions.
    // Our server can refuse to respond to requests from the wrong locations
    navigator.geolocation.getCurrentPosition(BR_handleGeolocation, BR_handleGeolocationFailed);
    navigator.geolocation.watchPosition(BR_handleGeolocation);
	
	// We need use push notifications support in this application.
	CORE_initializePushNotifications("319678326152");
	
	// Enable Hype
	window.hypeSesh = new HypeSesh({frequency: 200});
	window.hypeSesh.start();
	
	// We start on the splash screen.
	CORE_switchToPage("splash","#000000");
	
    // Start network connection
    BR_createPollConection(4000,BR_handleServerStatus);
	
	// Some draw handling
    window.OKToDraw = true;
    window.DrawWaiting = false;
    
	var drawingCanvas = document.getElementById("drawingCanvas");
	$(drawingCanvas).bind("mouseup touchend mouseleave touchleave", function(){
		var send = document.getElementById("drawSend");
        if(window.OKToDraw){send.style.display = "block";}
        else{send.style.display = "none";}
	});
    $(drawingCanvas).bind("mousedown touchstart touchenter", function(){
        var colorpicker = document.getElementById("colorPicker");
        colorpicker.style.display = "none";
        window.DrawWaiting = true;
    });
    $(document).bind("dataSend",function(){
        window.OKToDraw = true;
        if(window.DrawWaiting)
        {
            document.getElementById("drawSend").style.display = "block";
        }
    });
}

/* Geolocation Functions */
var THREEAM_POSITION_LATITUDE = "";
var THREEAM_POSITION_LONGITUDE = "";
function BR_handleGeolocation(position)
{
    THREEAM_POSITION_LATITUDE = position.coords.latitude;
    THREEAM_POSITION_LONGITUDE = position.coords.longitude;
}
function BR_handleGeolocationFailed(error)
{
    THREEAM_POSITION_LATITUDE = "";
    THREEAM_POSITION_LONGITUDE = "";
    if(error.code == 1)
    {
        //We don't have permission!!
        THREEAM_POSITION_LATITUDE = "NOPERM";
        THREEAM_POSITION_LONGITUDE = "NOPERM";
    }
}

/* Network Functions */
var THREEAM_NETWORK_PACKET = {
    NETWORK_SERVER: "http://amobspyomec.thedeepwebtour.com:80",
    NETWORK_ENDPOINT: "status",
	NETWORK_VERSION: BR_majorVersionNumber,
    DATA: ""
};
var THREEAM_NETWORK_QUEUE;
var THREEAM_NETWORK_IDENTIFIER = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {var r = Math.random()*16|0,v=c=='x'?r:r&0x3|0x8;return v.toString(16);});
var THREEAM_NETWORK_STATUS = "";
// /drawings/submit
function BR_submitDrawing(data)
{
    BR_queueToNetwork("drawings/submit",data,BR_handleServerStatus);
}
function BR_voteIDFromElm(elm)
{
    elm = elm.replace("Question","");
    elm = parseInt(elm)-1;
    return ""+elm;
}
function BR_removeVote(elm)
{
    var data = {
        id: BR_voteIDFromElm(elm),
        value: "-1"
    };
    BR_queueToNetwork("votes/submit",data,BR_handleServerStatus);
}
function BR_addVote(elm,remelm)
{
    var data = {
        add: BR_voteIDFromElm(elm),
        remove: BR_voteIDFromElm(remelm),
    };
    BR_queueToNetwork("votes/submit",data,BR_handleServerStatus)
}
function BR_addVoteNSong(elm,remelm)
{
    var data = {
        add: BR_voteIDFromElm(elm),
        remove: BR_voteIDFromElm(remelm),
    };
    BR_queueToNetwork("newsong/submit",data,BR_handleServerStatus)
}
function BR_sendStartVote()
{
    //Deprecated
    //BR_queueToNetwork("button/start","1",BR_handleServerStatus);
}
function BR_sendMessage(data)
{
    BR_queueToNetwork("messages/submit",data,BR_handleServerStatus);
}
function BR_introduceNetworkIdentifiers(data)
{
    if(data==""){data = {};}
    data.deviceLatitude = THREEAM_POSITION_LATITUDE;
    data.deviceLongitude = THREEAM_POSITION_LONGITUDE;
    data.deviceIdentifier = THREEAM_NETWORK_IDENTIFIER;
	data.deviceVersion = THREEAM_NETWORK_PACKET.NETWORK_VERSION;
	data.devicePushPlatform = CORE_pushPlatform;
	data.devicePushIdentifier = CORE_pushIdentifier;
	data.deviceHype = window.hypeSesh.runningAvg.mean;
	window.hypeSesh.reset();
    return data;
}
function BR_queueToNetwork(endpoint,data,callback)
{    
    if(THREEAM_NETWORK_PACKET.DATA == "")
    {
        THREEAM_NETWORK_PACKET.NETWORK_ENDPOINT = endpoint;
        THREEAM_NETWORK_PACKET.DATA = data;
    }else{
        BR_sendToNetwork(THREEAM_NETWORK_PACKET.NETWORK_ENDPOINT,
                         THREEAM_NETWORK_PACKET.DATA,
                         callback);
        THREEAM_NETWORK_PACKET.NETWORK_ENDPOINT = endpoint;
        THREEAM_NETWORK_PACKET.DATA = data;
    }
}
function BR_sendToNetwork(endpoint,data,callback)
{
	$.support.cors = true;
	$.ajax({
		url: THREEAM_NETWORK_PACKET.NETWORK_SERVER+"/"+endpoint,
		dataType: 'json',
		type: 'POST',
		data: BR_introduceNetworkIdentifiers(data)
	}).done(function(data) 
	{
		callback(data);
	}).fail(function(jqXHR, textStatus, errorThrown){
		//alert(textStatus + ": " + errorThrown);
		callback(false);
	});
}
function BR_createPollConection(delay, callback)
{
    THREEAM_NETWORK_QUEUE = window.setInterval(function(){
        BR_sendToNetwork(THREEAM_NETWORK_PACKET.NETWORK_ENDPOINT,
                         THREEAM_NETWORK_PACKET.DATA,
                         callback);
        THREEAM_NETWORK_PACKET.DATA = "";
        THREEAM_NETWORK_PACKET.NETWORK_ENDPOINT = "status";
    }, delay);
    BR_sendToNetwork(THREEAM_NETWORK_PACKET.NETWORK_ENDPOINT,
                     THREEAM_NETWORK_PACKET.DATA,
                     callback);
    THREEAM_NETWORK_PACKET.DATA = "";
    THREEAM_NETWORK_PACKET.NETWORK_ENDPOINT = "status";
}
function BR_handleServerStatus(data)
{
    var status = "0";
    var src = $("#splash .start").css("background-image");
    if(THREEAM_POSITION_LATITUDE == "NOPERM")
    {
        status = "-1";
        $("#splash .start").css("display","block");
        $("#splash .start").addClass("pulse");
        src = src.replace("network.svg","location.svg");
        src = src.replace("start.svg","location.svg");
        $("#splash .start").css("background-image",src);
        $("#splash .start").css("background-image",src);
    }else if(typeof data.state !== "undefined")
    {
        status = data.state;
        $("#splash .start").css("display","block");
        $("#splash .start").addClass("pulse");
        src = src.replace("network.svg","start.svg");
        src = src.replace("location.svg","start.svg");
        $("#splash .start").css("background-image",src);
        $("#splash .start").css("background-image",src);
    }else{
        status = "-1";
        $("#splash .start").css("display","block");
        $("#splash .start").removeClass("pulse");
        src = src.replace("location.svg","network.svg");
        src = src.replace("start.svg","network.svg");
        $("#splash .start").css("background-image",src);
        $("#splash .start").css("background-image",src);
    }
    
    $(document).trigger("dataSend");
    
    if(THREEAM_NETWORK_STATUS != status)
    {
        THREEAM_NETWORK_STATUS = status;
        if(window.CORE_currentPage != "#splash")
        {
            CORE_switchToPage(BR_getPageFromStatusCode(status),BR_getColorFromStatusCode(status));   
        }
    }
    if(THREEAM_POSITION_LATITUDE == "NOPERM")
    {
        if(window.CORE_currentPage != "#splash")
        {
            CORE_switchToPage(BR_getPageFromStatusCode(status),BR_getColorFromStatusCode(status));   
        }
    }
}
function BR_getColorFromStatusCode(code)
{
    code = ""+code;
    if(code == ""){code = "0";}
    if(code == "2" || code == "0" || code == "-1" || code == "999")
        return "#000000";
    return CORE_deflColor;
}
function BR_getPageFromStatusCode(code)
{
    //Server Stati
    //  0: Unactive
    //  1: Draw/Chat
    //  2: Power Button
    //  3: Voting
	//  4: VotingNSong
    //999: Incorrect Venue
    code = ""+code;
    if(code==""){code="0";}
    switch(code)
    {
        case "0":
            return "wait";
            break;
        case "1":
            return "draw";
            break;
        case "2":
            return "power";
            break;
        case "3":
            return "choice";
            break;
		case "4":
            return "newsong";
            break;
        case "999":
            return "geogate";
            break;
        default:
            return "splash";
    }
}

$(document).ready(function() 
{
    var isPhone = false;
    if(document.URL.indexOf("http://") === -1 && document.URL.indexOf("https://") === -1) 
    {
        isPhone = true;
    }

    if(isPhone) 
    {
        document.addEventListener("deviceready", onDeviceReady, false);
    } else {
        onDeviceReady();
    }
});

function onDeviceReady() {
    BR_startApplication();	
}