/* Brown Recluse                       */
/* Deep Web Tour Companion Application */
/* 2014 3am LLC - http://3amteam.com   */

/* Core.js - Mobile Application Support Functions */

function CORE_switchToPage(page,color)
{
	page = "#"+page;
    
    // Make sure keyboards are 100% Totally Gone(TM)
    if (document.activeElement && document.activeElement.blur && document.activeElement !== document.body) {
        document.activeElement.blur();
    }
    else {
        $(':focus').blur();
    }
    $('input').blur();
    $('textarea').blur();
    $('*').blur();
	
	setTimeout(function(){
    	CORE_FixAndroidKeyboard();
	},0);
    
    // Animations!
    function scale(amt)
    {
        $(window.CORE_currentPage).css({
            'transform': 'scale(' + amt + ')',
            '-moz-transform': 'scale(' + amt + ')',
            '-webkit-transform': 'scale(' + amt + ')',
            '-ms-transform': 'scale(' + amt + ')'
        });
    }
    function statusColor(color)
    {
        if(typeof color !== "undefined")
        {
            document.body.style.backgroundColor = color;
            if(typeof StatusBar !== "undefined")
            {
                if(iOS7)
                    StatusBar.backgroundColorByHexString(color);
            }
        }else{
            document.body.style.backgroundColor = CORE_deflColor;
            if(typeof StatusBar !== "undefined")
            {
                if(iOS7)
                    StatusBar.backgroundColorByHexString(CORE_deflColor);
            }
        }   
    }
    function switchPageInternal(anim)
    {
        CORE_lazyLoadImages(page);
        
        window.CORE_currentPage = page;
		
		CORE_FixAndroidKeyboard();
        
        if(anim){scale("0");}
        
        document.body.style.height = window.innerHeight-parseInt($(document.body).css('margin-top'))+"px";
		
		CORE_FixAndroidKeyboard();
        
        $(window.CORE_currentPage).show();
		
		CORE_FixAndroidKeyboard();
		
		setTimeout(function(){
			document.body.style.height = window.innerHeight-parseInt($(document.body).css('margin-top'))+"px";
			CORE_FixAndroidKeyboard();
		},0);
		
        if(anim){
            setTimeout(function(){scale("1");CORE_FixAndroidKeyboard();},0);
        }
        
        CORE_lazyLoadScripts(page);
    }
    function switchPage(anim)
    {
        if(!anim){switchPageInternal(false);statusColor(color);}
        else
        {
            $(window.CORE_currentPage).css("top","-100%");
            statusColor("#000000");
            setTimeout(function(){
                $(window.CORE_currentPage).hide();
                $(window.CORE_currentPage).css("top","0");
                switchPageInternal(true);
                setTimeout(function(){
                    statusColor(color);
                },500);
            },500);
        }
    }
    
	if(window.CORE_currentPage !== undefined){switchPage(true);}else{switchPage(false);}
}

var iOS = navigator.userAgent.match(/iphone|ipad|ipod/i);
    var iOS7 = iOS &&
        parseInt(navigator.appVersion.match(/OS (\d)/)[1], 10) >= 7;

function CORE_FixAndroidKeyboard()
{
    if(typeof SoftKeyboard !== "undefined")
    {
        SoftKeyboard.hide();
    }
}

function CORE_iOSStatusBarCompensationEnabler(color)
{   
    document.body.style.backgroundColor = color;
    
    if ((iOS7 && ((typeof window.navigator.standalone !== "undefined" && window.navigator.standalone == true)||(typeof window.cordova !== "undefined")))||(iOS && typeof window.navigator.standalone !== "undefined" && window.navigator.standalone == true)) {
        document.body.style.marginTop = '20px';
        document.body.style.height = window.innerHeight-20+"px";
    }
    if(typeof StatusBar !== "undefined")
    {
            StatusBar.overlaysWebView(true);
            StatusBar.styleLightContent();
    }
}

function CORE_iOSKeyboardHandlerHelperA(e)
{
    if(iOS)
    {
        var val = e.target.value;
        e.target.value += " ";
        setTimeout(function(){
			e.target.value = val;
			CORE_iOSKeyboardHandler();
			//$(window).trigger("resize");
		},0);
		//$(window).trigger("resize");
    }
}

function CORE_iOSKeyboardHandlerHelperB(e)
{
    if(iOS)
    {
        document.body.style.height = window.innerHeight-parseInt($(document.body).css('margin-top'))+"px";
		CORE_iOSKeyboardHandler();
        //$(window).trigger("resize");
    }
}

function CORE_iOSKeyboardHandler()
{
    var compensation = 0;
    if(typeof window.cordova !== "undefined")
    {
        //compensation = 2;
    }
    var virtualKeyboardHeight = function () {
        var sx = document.body.scrollLeft, sy = document.body.scrollTop;
        var naturalHeight = window.innerHeight;
        window.scrollTo(sx, document.body.scrollHeight);
        var keyboardHeight = naturalHeight - window.innerHeight;
        window.scrollTo(sx, sy);
        return keyboardHeight;
    };    
    document.body.style.height = window.innerHeight-virtualKeyboardHeight()-parseInt($(document.body).css('margin-top'))+compensation+"px";
    $(window).scrollTop(0);
}
function CORE_lazyLoadImages(page)
{
	$(page+" *[data-src]").each(function(){
		var data = $(this).data('src');
		this.src = data;
	});
	$(page+" *[data-class]").each(function(){
		var data = $(this).data('class');
		this.className += " "+data;
	});
}
function CORE_lazyLoadScripts(page)
{
    prefix = CORE_prefix+"_load_";
    $(page+" *[data-load]").each(function(){
		var data = $(this).data('load');
		eval(prefix+data+"();");
	});
}
function CORE_addActionSupport(prefix)
{
    CORE_prefix = prefix;
	prefix = prefix+"_action_";
	$("*[data-action]").each(function(){
		var data = $(this).data('action');
		$(this).unbind("touchend");
		$(this).bind("touchend", function(e){window[prefix+data](e);return false;});
	});
}
function CORE_loadSVGImage(el,src)
{
    el.style.display = "none"; // See comment below
    el.src = src
    setTimeout(function(){el.style.display = "";},0); // Why is iOS WebKit super buggy with SVG
}
function CORE_initializePushNotifications(GCMID) {
	if(typeof window.plugins !== "undefined" 
	   && typeof window.plugins.pushNotification !== "undefined")
	{
		var pushNotification = window.plugins.pushNotification;
		if (device.platform == "android" || device.platform == "Android")
		{
			pushNotification.register(function(){},
									  function(){},
									  {
									  "senderID":GCMID,
									  "ecb":"CORE_onNotificationGCM"
									  });
		}else if (device.platform == "iOS"){
			pushNotification.register(
				function(res){
					CORE_pushIdentifier = res;
					CORE_pushPlatform = "iOS";
					//alert(res);
				},
				function(){},
				{
					"badge":"true",
					"sound":"true",
					"alert":"true",
					"ecb":"CORE_onNotificationAPN"
				}
			);  
		}
	}
}
function CORE_onNotificationAPN(event)
{
	var pushNotification = window.plugins.pushNotification;
	if (event.alert) {
		navigator.notification.alert(event.alert);
	}
	if (event.badge) {           
			pushNotification.setApplicationIconBadgeNumber(
				this.successHandler, 
				event.badge
			);
	}
	if (event.sound) {
		var snd = new Media(event.sound);
		snd.play();
	}
}
function CORE_onNotificationGCM(e)
{
	switch( e.event )
	{
		case 'registered':
			if ( e.regid.length > 0 )
			{
				CORE_pushIdentifier = e.regid;
				CORE_pushPlatform = "Android";
			}
			break;
		case 'message':
			//alert('message = '+e.message);
			break;
		case 'error':
			//alert('GCM error = '+e.msg);
			break;
		default:
			//alert('An unknown GCM event has occurred');
			break;
	}

}
CORE_prefix = "";
CORE_pushIdentifier = "UNKWN";
CORE_pushPlatform = "UNKWN;"
window.addEventListener("resize",CORE_iOSKeyboardHandler);
$(document).on('focus', 'input[type=text]:visible, textarea:visible',CORE_iOSKeyboardHandlerHelperA);
$(document).on('blur', 'input[type=text]:visible, textarea:visible',CORE_iOSKeyboardHandlerHelperB);
document.ontouchmove = function(e) {e.preventDefault()};